﻿using System;
using System.Collections.Generic;
using System.IO;
using CoreLib.Graphics;
using CoreLib.Io;
using CoreLib;
using System.Threading;

using MapUtility;

namespace MapEditor
{
	/// <summary>
	/// A static class for creating adjacent.tbl.
	/// </summary>
	internal static class AdjacentMaker
	{
		#region Old Junk
		/*private const int BoxSize = 100;
		public const string LayerName = "ProvID";
		private static RgbImageData LoadFile(LineData line, RgbImageData wrap)
		{
			Console.WriteLine("Working on file: " + line.FilePath);
			Layer l;
			if (line.FileType == FileTypes.Photoshop)
			{
				FileReader fr;
				try
				{
					fr = new FileReader(line.FilePath);
				}
				catch (System.IO.FileNotFoundException)
				{
					Console.WriteLine("The following file was not found: " + line.FilePath);
					return null;
				}
				l = fr.Layers[LayerName];
				if (l == null)
				{
					Console.WriteLine("A layer named \"ProvID\" was not found in the file: " + line.FilePath);
					Console.WriteLine("Now exiting...");
					return null;
				}

				l.LoadPic();

				if (line.xOffset == 0)
				{
					RgbImageData.Copy((RgbImageData)
						l.PictureData, 0, 0, wrap, 5, line.yOffset * 32, 5, l.Bounds.Height);
				}
				if (line.xOffset + l.Bounds.X / 32 == 935)
				{
					RgbImageData.Copy((RgbImageData)
						l.PictureData, l.Bounds.Right - 5, 0, wrap, 0, line.yOffset * 32, 5, l.Bounds.Height);
				}

				return (RgbImageData)l.PictureData;
			}
			else if (line.FileType == FileTypes.SimpleImages)
			{
				System.Drawing.Bitmap b = new System.Drawing.Bitmap(line.ProvinceOwnershipPath);
				l = new Layer();
				l.PictureData = RgbImageData.ToData(new System.Drawing.Bitmap(line.ProvinceOwnershipPath));
				l.Bounds = new System.Drawing.Rectangle(0, 0, l.PictureData.Width, l.PictureData.Height);
				l.LoadPic();

				if (line.xOffset == 0)
				{
					RgbImageData.Copy((RgbImageData)
						l.PictureData, 0, 0, wrap, 5, line.yOffset * 32, 5, l.Bounds.Height);
				}
				if (line.xOffset + l.Bounds.Right / 32 == Global.Lm1Width)
				{
					RgbImageData.Copy((RgbImageData)
						l.PictureData, l.Bounds.Right - 5, 0, wrap, 0, line.yOffset * 32, 5, l.Bounds.Height);
				}


				return (RgbImageData)l.PictureData;
			}
			else
			{
				Console.WriteLine("Unknown type: " + line.Extension);
				return null;
			}
		}*/
		/*private static Dictionary<int, Region> GetRegions(RgbImageData imgData, int xfirst, int yfirst)
		{
			RgbData colorData;
			regions.Clear();

			int startX, endX, startY, endY;
			startX = xfirst - 1;
			if (startX < 0) startX = 0;
			startY = yfirst - 1;
			if (startY < 0) startY = 0;
			endX = xfirst + BoxSize + 1;
			if (endX > imgData.Width) endX = imgData.Width;
			endY = yfirst + BoxSize + 1;
			if (endY > imgData.Height) endY = imgData.Height;

			int id;
			for (int x = startX; x < endX; x++)
			{
				for (int y = startY; y < endY; y++)
				{
					colorData = imgData.GetPixel(x, y);
					try
					{
						id = Shared.ColorToId[colorData];
						if (!regions.ContainsKey(id))
							regions.Add(id, new Region());
						regions[id].FastAdd(x, y);
					}
					catch (KeyNotFoundException)
					{
						Console.WriteLine("Invalid color: " + colorData.ToString());
						continue;
					}
				}
			}
			return regions;
		}
		private static Dictionary<int, Region> GetRegions(OwnershipData imgData)
		{
			regions.Clear();

			for (int x = 0; x < 32; x++)
			{
				for (int y = 0; y < 32; y++)
				{
					int ownerId = imgData[y * 32 + x].ownerId;
					try
					{
						if (!regions.ContainsKey(ownerId))
							regions.Add(ownerId, new Region());
						regions[ownerId].FastAdd(x, y);
					}
					catch (KeyNotFoundException)
					{
						Console.WriteLine("Invalid color: " + ownerId.ToString());
						continue;
					}
				}
			}
			return regions;
		}*/
		/*public static void MakeAdjacent(List<LineData> files)
		{
			int maxProvNum = Shared.QueryMaxProvinceNumber();

			WorkTimer timer = new WorkTimer();
			timer.BeginJob("Making adjacent table");
			timer.BeginJob("Populating adjancies");
			List<List<int>> adjancies = new List<List<int>>(maxProvNum);
			for (int i = 0; i < maxProvNum; i++)
			{
				adjancies.Add(new List<int>());
			}
			timer.EndJob();

			RgbImageData wrap = new RgbImageData(10, 360 * 32); //Because the map warps around
			foreach (LineData line in files)
			{
				timer.BeginJob("Loading from file: " + line.ProvinceOwnershipPath);
				RgbImageData imgData = LoadFile(line, wrap);
				if (imgData == null) return; //There was an error somewhere
				int numBlocks = (imgData.Width / BoxSize + 1) - 1;
				int count = 0;
				for (int x = 0; x < imgData.Width; x += BoxSize)
				{
					Console.WriteLine("Doing column {0} of {1}", count++, numBlocks);
					for (int y = 0; y < imgData.Height; y += BoxSize)
					{
						Dictionary<int, Region> regions = GetRegions(imgData, x, y);
						if (regions.Count < 2) continue;
						foreach (KeyValuePair<int, Region> kvp1 in regions)
						{
							foreach (KeyValuePair<int, Region> kvp2 in regions)
							{
								DoPair(adjancies, kvp1, kvp2);
							}
						}
					}
				}
				timer.EndJob();
			}
			{
				for (int x = 0; x < wrap.Width; x += BoxSize)
				{
					for (int y = 0; y < wrap.Height; y += BoxSize)
					{
						Dictionary<int, Region> regions = GetRegions(wrap, x, y);
						if (regions.Count < 2) continue;
						foreach (KeyValuePair<int, Region> kvp1 in regions)
						{
							foreach (KeyValuePair<int, Region> kvp2 in regions)
							{
								DoPair(adjancies, kvp1, kvp2);
							}
						}
					}
				}
			}
			timer.BeginJob("Writing to output");
			WriteToFile(adjancies, maxProvNum);
			timer.EndJob();
			timer.EndJob();
		}*/
		#endregion

		static object listLock = new object();
		static object readLock = new object();

		/// <summary>
		/// Creates a list of province ids and their associated regions.
		/// </summary>
		/// <param name="imgData">The array containing the province ownership id data.</param>
		/// <returns>A Dictionary&ltint, Region> containing ids and their regions.</returns>
		private static Dictionary<int, Region> GetRegions(ushort[,] imgData)
		{
			Dictionary<int, Region> ret = new Dictionary<int, Region>(10);

			int width = imgData.GetLength(0);
			int height = imgData.GetLength(1);

			for (int x = 0; x < width; x++)
			{
				for (int y = 0; y < height; y++)
				{
					int ownerId = imgData[x, y];
					if (ownerId == 0)
						continue;
					try
					{
						if (!ret.ContainsKey(ownerId))
							ret.Add(ownerId, new Region(width * height));
						ret[ownerId].FastAdd(x, y);
					}
					catch (KeyNotFoundException)
					{
						Console.WriteLine("Invalid color: " + ownerId.ToString());
						continue;
					}
				}
			}
			return ret;
		}
		/// <summary>
		/// Writes the adjacent data to a file.
		/// </summary>
		/// <param name="adjancies">The list of provinces and their adjancies.</param>
		/// <param name="maxProvNum">The max province number.</param>
		private static void WriteToFile(List<List<int>> adjancies, int maxProvNum)
		{
			foreach (List<int> lst in adjancies)
			{
				lst.Sort((x, y) => x - y);
			}
			adjancies[0].Clear();

			//Somehow, some are adjacent to province 0. This must not happen.
			foreach (List<int> lst in adjancies)
			{
				if (lst.Contains(0))
					lst.Remove(0);
			}

			//If some provinces are missing we add them
			int offset = 0;
			using (BinaryWriter bw = new BinaryWriter(new FileStream(Shared.AdjacentPath, FileMode.Create)))
			{
				bw.Write(offset);
				//Write offsets
				foreach (List<int> lst in adjancies)
				{
					offset += lst.Count;
					bw.Write(offset);
				}
				foreach (List<int> lst in adjancies)
				{
					foreach (int adjProvince in lst)
					{
						bw.Write(adjProvince);
						bw.Write(Zero);
						bw.Write(Filler);
					}
				}
			}
		}
		/// <summary>
		/// Studies two province id regions to see if they intersect, adding them to the list of adjancies if necessary.
		/// </summary>
		/// <param name="adjancies">The current adjancy table.</param>
		/// <param name="kvp1">The first region to compare.</param>
		/// <param name="kvp2">The second region to compare.</param>
		private static void DoPair(List<List<int>> adjancies, KeyValuePair<int, Region> kvp1, KeyValuePair<int, Region> kvp2)
		{
			if (kvp1.Key == kvp2.Key) return;

			//Here we check if it already has the adjacent province
			lock (listLock)
			{
				if (adjancies[kvp1.Key].Contains(kvp2.Key))
					return;
			}

			if (kvp1.Value.IsAdjacentTo(kvp2.Value))
			{
				lock (listLock)
				{
					if (!adjancies[kvp1.Key].Contains(kvp2.Key))
						adjancies[kvp1.Key].Add(kvp2.Key);
					if (!adjancies[kvp2.Key].Contains(kvp1.Key))
						adjancies[kvp2.Key].Add(kvp1.Key);
				}
			}
		}
		/// <summary>
		/// Creates adjacent.tbl by scanning the combined lightmap1 radish file
		/// </summary>
		public static void MakeAdjacent()
		{
			Console.WriteLine("Working...");
			DateTime startTime = DateTime.Now;
			Console.WriteLine("Start time: {0}", startTime.ToString());

			int maxProvNum = Settings.QueryMaxProvinceNumber();
			List<List<int>> adjancies = new List<List<int>>(maxProvNum);
			for (int i = 0; i < maxProvNum; i++)
			{
				adjancies.Add(new List<int>());
			}
			int howManyRowsToMoveAtTime = 10000 / Settings.Lm1Width;
			int numTimes = Settings.Lm1Height / howManyRowsToMoveAtTime + 1;

			Shared.Lightmap1RadishHeaders.ToString(); //To force load to not conflict with following bytereader

			using (ByteReader br = new ByteReader(Shared.Lightmap1RadishPath, false))
			{
				TaskQueue adjJobs = new TaskQueue(numTimes);
				for (int i = 0; i < numTimes; i++)
				{
					int start = howManyRowsToMoveAtTime * i;
					if (start > Settings.Lm1Height)
						continue;
					int end = start + howManyRowsToMoveAtTime;
					if (end > Settings.Lm1Height)
						end = Settings.Lm1Height;
					int readEnd = end + 1;
					if (readEnd > Settings.Lm1Height)
						readEnd = Settings.Lm1Height;

					adjJobs.Add(new DoAdjacentTask(start, readEnd, end, br, Shared.Lightmap1RadishHeaders, adjancies,
						Console.CursorTop));
				}

				adjJobs.StartWork();
				adjJobs.FinishAll();
				/*Console.WriteLine("Press any key to view current status...");
				while (true)
				{
					Thread.Sleep(2000);
					if (adjJobs.AllIsDone)
						break;
					if (Console.KeyAvailable)
					{
						Console.ReadKey(true);
						string[] desc = adjJobs.GetCurrentTaskDescriptions();

						Console.WriteLine();
						Console.WriteLine("Status as of " + DateTime.Now);
						for (int i = 0; i < desc.Length; i++)
							Console.WriteLine("Thread {0}: \r\n{1}", i + 1, desc[i]);
					}
				}*/
			}

			Console.WriteLine("Done calculating adjancies!");

			DoAdjModFile(maxProvNum, adjancies);

			Console.WriteLine("Writing to file...");
			WriteToFile(adjancies, maxProvNum);
			Console.WriteLine("Done!");
			DateTime endTime = DateTime.Now;
			Console.WriteLine("Finished at {0}", endTime.ToString());
			Console.WriteLine("Total time elapsed: {0}", (endTime - startTime).ToString());
		}

		private static void DoAdjModFile(int maxProvNum, List<List<int>> adjancies)
		{
			if (CoreLib.Io.File.Exists("adj-mod.txt"))
			{
				List<string> lines = CoreLib.Io.File.ReadAndCleanLines("adj-mod.txt");
				foreach (string s in lines)
				{
					string[] parts = s.Split(';');
					#region Check that has enough args
					if (parts.Length < 3)
					{
						Console.WriteLine();
						Console.WriteLine("Invalid line: {0}", s);
						Console.WriteLine("Skipped.");
						Console.WriteLine();
						continue;
					}
					#endregion
					ushort first, second;
					#region Parse ids
					if (!ushort.TryParse(parts[0], out first))
					{
						Console.WriteLine();
						Console.WriteLine("Invalid province id: {0}", parts[0]);
						Console.WriteLine(" at {0}", s);
						Console.WriteLine("Skipped.");
						Console.WriteLine();
						continue;
					}
					if (!ushort.TryParse(parts[1], out second))
					{
						Console.WriteLine();
						Console.WriteLine("Invalid province id: {0}", parts[1]);
						Console.WriteLine(" at {0}", s);
						Console.WriteLine("Skipped.");
						Console.WriteLine();
						continue;
					}
					#endregion
					#region Check that vals are within range
					if (first > maxProvNum || second > maxProvNum)
					{
						Console.WriteLine();
						Console.WriteLine("Invalid province id: {0}", first > maxProvNum ? first.ToString() : second.ToString());
						Console.WriteLine(" at {0}", s);
						Console.WriteLine("Skipped.");
						Console.WriteLine();
						continue;
					}
					#endregion
					if (parts[2] == "Add")
					{
						if (!adjancies[first].Contains(second))
							adjancies[first].Add(second);
					}
					else if (parts[2] == "Delete")
					{
						adjancies[first].Remove(second);
					}
					#region If command is invalid
					else
					{
						Console.WriteLine();
						Console.WriteLine("Invalid command. Command must be \"Add\" or \"Delete\".");
						Console.WriteLine("Invalid: {0}", parts[2]);
						Console.WriteLine(" at {0}", s);
						Console.WriteLine();
						Console.WriteLine("Skipped.");
						continue;
					}
					#endregion
				}
			}
		}
		/// <summary>
		/// Scans a part of the map and adds to the adjacent table as necessary. This is done to not cause OutOfMemoryExceptions.
		/// </summary>
		/// <param name="rowStart">The row to start scanning.</param>
		/// <param name="loadRowEnd">The last row to load. Generally one more than last scan row, unless at bottom.</param>
		/// <param name="scanRowEnd">The last row to scan for adjacent information.</param>
		/// <param name="stream">The stream containing the map information.</param>
		/// <param name="headers">A list of headers of the blocks.</param>
		/// <param name="adjancies">The current adjancy table.</param>
		private static void MakeAdjacent(int rowStart, int loadRowEnd, int scanRowEnd, ByteReader stream, BlockHolder[,] headers,
			List<List<int>> adjancies, DoAdjacentTask task)
		{
			task.IsLoadingRow = true;

			OwnershipData[,] blocks = LoadRows(rowStart, loadRowEnd, stream, headers, task);

			task.IsLoadingRow = false;

			DoRows(rowStart, scanRowEnd, adjancies, blocks, task);
		}

		private static void DoRows(int rowStart, int scanRowEnd, List<List<int>> adjancies,
			OwnershipData[,] blocks, DoAdjacentTask task)
		{
			for (int y = rowStart; y < scanRowEnd; y++)
			{
				task.currentRow = y;
				//task.RefreshData();
				for (int x = 0; x < Width; x++)
				{
					ushort[,] data = LoadDataArray(blocks, y, x);

					if (data == null)
						continue;

					Dictionary<int, Region> regions = GetRegions(data);

					if (CheckSpecialCases(adjancies, regions))
						continue;

					foreach (KeyValuePair<int, Region> kvp1 in regions)
					{
						foreach (KeyValuePair<int, Region> kvp2 in regions)
						{
							DoPair(adjancies, kvp1, kvp2);
						}
					}
				}
			}
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="adjancies"></param>
		/// <param name="regions"></param>
		/// <returns>True if was a special case.</returns>
		private static bool CheckSpecialCases(List<List<int>> adjancies, Dictionary<int, Region> regions)
		{
			if (regions.Count < 2) return true;
			if (regions.Count == 2)
			{
				int key1 = 0, key2 = 0, inc = 0;
				foreach (KeyValuePair<int, Region> kvp in regions)
				{
					if (inc == 0)
					{
						inc++;
						key1 = kvp.Key;
					}
					else
						key2 = kvp.Key;
				}

				lock (listLock)
				{
					if (adjancies[key1].Contains(key2))
						return true;

					adjancies[key1].Add(key2);
					adjancies[key2].Add(key1);
					return true;
				}
			}
			return false;
		}

		private static OwnershipData[,] LoadRows(int rowStart, int loadRowEnd, ByteReader stream,
			BlockHolder[,] headers, DoAdjacentTask task)
		{
			OwnershipData[,] blocks = new OwnershipData[Width, Height];

			lock (readLock)
			{
				for (int y = rowStart; y < loadRowEnd; y++)
				{
					task.currentRow = y;
					//task.RefreshData();
					for (int x = 0; x < Width; x++)
					{
						blocks[x, y] = RadishHelper.LoadBlockData(x, y, headers, stream).Ownership;
					}
				}
			}

			return blocks;
		}

		private static ushort[,] LoadDataArray(OwnershipData[,] blocks, int y, int x)
		{
			const int borderLength = 2;

			OwnershipData main = blocks[x, y];
			OwnershipData left = blocks[x > 0 ? x - 1 : Width - 1, y];
			OwnershipData right = blocks[x < Width - 1 ? x + 1 : 0, y];

			ushort[,] data = new ushort[32 + 2 * borderLength, 32 + borderLength];

			//Bottom three
			if (y < Height - 1)
			{
				OwnershipData bottomLeft = blocks[x > 0 ? x - 1 : Width - 1, y + 1];
				OwnershipData bottom = blocks[x, y + 1];
				OwnershipData bottomRight = blocks[x < Width - 1 ? x + 1 : 0, y + 1];

				//Check if we actually need to copy anything
				if (main.Compressed && left.Compressed && right.Compressed
					&& bottomLeft.Compressed && bottom.Compressed && bottomRight.Compressed)
					return null;

				Copy(bottomLeft, 32 - borderLength, 0, data, 0, 32, borderLength, borderLength);
				Copy(bottom, 0, 0, data, borderLength, 32, 32, borderLength);
				Copy(bottomRight, 0, 0, data, borderLength + 32, 32, borderLength, borderLength);
			}

			//Do we need to waste time copying?
			if (main.Compressed && left.Compressed && right.Compressed && y == Height - 1)
				return null;

			Copy(main, 0, 0, data, borderLength, 0, 32, 32);
			Copy(left, 32 - borderLength, 0, data, 0, 0, borderLength, 32);
			Copy(right, 0, 0, data, 32 + borderLength, 0, borderLength, 32);



			return data;
		}

		#region Constant Numbers
		static readonly int Width = Settings.Lm1Width;
		static readonly int Height = Settings.Lm1Height;

		private const int Zero = 0;
		private const uint Filler = 0xCDCDCDCD;
		#endregion

		/// <summary>
		/// Copies data from a OwnershipData to a ushort[,].
		/// </summary>
		/// <param name="source">The OwnershipData serving as the source.</param>
		/// <param name="sourceX">The x-position of the source to begin copying.</param>
		/// <param name="sourceY">The y-position of the source to begin copying.</param>
		/// <param name="dest">The ushort[,] to copy to.</param>
		/// <param name="destX">The x-position of the destination to begin recording.</param>
		/// <param name="destY">The y-position of the destination to begin recording.</param>
		/// <param name="width">The width of the area to copy.</param>
		/// <param name="height">The height of the area to copy.</param>
		private static void Copy(OwnershipData source, int sourceX, int sourceY, ushort[,] dest, int destX, int destY,
			int width, int height)
		{
			for (int x = 0; x < width; x++)
				for (int y = 0; y < height; y++)
				{
					dest[destX + x, destY + y] = source[sourceX + x + (sourceY + y) * 32].OwnerId;
				}
		}

		class DoAdjacentTask : Task
		{
			private static object ConsoleLock = new object();

			int rowStart;
			int loadRowEnd;
			int scanRowEnd;
			ByteReader stream;
			BlockHolder[,] headers;
			List<List<int>> adjancies;

			int cursorRow;

			public bool IsLoadingRow;
			public int currentRow;

			public DoAdjacentTask(int rowStart, int loadRowEnd, int scanRowEnd,
				ByteReader stream, BlockHolder[,] headers, List<List<int>> adjancies,
				int cursorRow)
				: base("aaa-aaa")
			{
				this.rowStart = rowStart;
				this.loadRowEnd = loadRowEnd;
				this.scanRowEnd = scanRowEnd;
				this.stream = stream;
				this.headers = headers;
				this.adjancies = adjancies;
				this.cursorRow = cursorRow;
				this.currentRow = rowStart;
			}

			public override string Description
			{
				get
				{
					return string.Format(@"
	RowStart: {0}
	LoadRowEnd: {1}
	ScanRowEnd: {2}"
//	{3}: {4}"
						, rowStart.ToString(), loadRowEnd.ToString(), scanRowEnd.ToString());
		 //IsLoadingRow ? "Loading row" : "Scanning Row", currentRow.ToString());
				}
			}
			public override void TaskOverride()
			{
				RefreshAllData();
				
				MakeAdjacent(rowStart, loadRowEnd, scanRowEnd, stream, headers, adjancies, this);
			}

			void RefreshAllData()
			{
				lock (ConsoleLock)
				{
					string[] statusData = Queue.GetCurrentTaskDescriptions();
					int rowtogetto = cursorRow + statusData.Length * 5 + 2;
					Console.CursorTop = cursorRow;
					Console.CursorLeft = 0;
					while (Console.CursorTop < rowtogetto)
						Console.Write(' ');

					Console.CursorTop = cursorRow;
					Console.CursorLeft = 0;

					Console.WriteLine("Status as of " + DateTime.Now);
					for (int i = 0; i < statusData.Length; i++)
						Console.WriteLine("Thread {0}: {1}", i + 1, statusData[i]);
				}
			}

			public void RefreshData()
			{
				lock (ConsoleLock)
				{
					int row = cursorRow + 5 * this.ThreadPosition + 5;
					Console.CursorTop = row;
					Console.CursorLeft = 0;
					Console.WriteLine(IsLoadingRow ? "\tLoading row: " : "\tScanning row: " + currentRow.ToString());
					Console.CursorLeft = 0;
					Console.CursorTop = cursorRow + 5 * Queue.NumThreads + 1;
				}
			}
		}
	}
}