﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HoiMapEditor
{
	public struct UshortFlag
	{
		public byte FlagOne;
		public byte FlagTwo;
		public ushort Value
		{
			get
			{
				return (ushort)(FlagOne * 256 + FlagTwo);
			}
		}
		public UshortFlag(byte FlagOne, byte FlagTwo)
		{
			this.FlagOne = FlagOne;
			this.FlagTwo = FlagTwo;
		}
		public bool this[int index]
		{
			get
			{
				if (index > 7) //Use flag2
				{
					return (FlagTwo & (1 << index - 8)) != 0;
				}
				else //Flag 1
				{
					return (FlagOne & (1 << index)) != 0;
				}
			}
			set
			{
				if (index > 7) //Flag2
				{
					if (value)
						FlagTwo |= (byte)(1 << index - 8);
					else
						FlagTwo &= (byte)(~(1 << index - 8));
				}
				else//flag1
				{
					if (value)
						FlagOne |= (byte)(1 << index);
					else
						FlagOne &= (byte)(~(1 << index));
				}
			}
		}
		public int GetNumber(int StartIndex, int EndIndex)
		{
			if (StartIndex > EndIndex)
			{
				int result = 0;
				for (; StartIndex >= EndIndex; StartIndex--)
				{
					result = result * 2 + (this[StartIndex] == true ? 1 : 0);
				}
				return result;
			}
			else if (StartIndex < EndIndex)
			{
				int result = 0;
				for (; StartIndex <= EndIndex; StartIndex++)
				{
					result = result * 2 + (this[StartIndex] == true ? 1 : 0);
				}
				return result;
			}
			else //Startindex==endindex
			{
				return this[StartIndex] == true ? 1 : 0;
			}
		}
		public bool[] Diagram
		{
			get
			{
				bool[] ret = new bool[16];
				for (int i = 0; i < 16; i++)
				{
					ret[i] = this[i];
				}
				return ret;
			}
		}
	}
}
