﻿using System.Drawing;
using CoreLib.Io;
using MapUtility;
using IO = System.IO;

namespace ObjectEditor
{
	sealed class BoundBox
	{
		private Rectangle[] Bounds;
		public BoundBox(string path)
		{
			int? maxPovNum = Settings.GetMaxProvNumber();

			if (maxPovNum == null)
			{
				System.Windows.MessageBox.Show("Missing MaxProvinceNumber entry in settings.txt. Now exiting!");
				System.Windows.Application.Current.Shutdown();
			}

			Bounds = new Rectangle[maxPovNum.Value];
			using (BinaryStream stream = new BinaryStream(new IO.FileStream(path, IO.FileMode.Open, IO.FileAccess.Read)))
			{
				for (int i = 0; i < maxPovNum; i++)
				{
					int x1 = stream.ReadInt32();
					int y1 = stream.ReadInt32();
					int x2 = stream.ReadInt32();
					int y2 = stream.ReadInt32();
					Bounds[i] = Rectangle.FromLTRB(x1, y1, x2, y2);
				}
			}
		}

		public Rectangle this[int id]
		{
			get
			{
				return Bounds[id];
			}
		}
	}
}