﻿using System.Collections.ObjectModel;
using System.IO;
using System.Linq;
using System.Windows;
using CoreLib.Compiliation.Ramixit;

namespace ObjectEditor
{
	public sealed class ViewableObjects : ObservableCollection<ViewableObject>
	{
		private const string ObjectsPath = "objects.txt";
		public int ProvinceNameColumn { get; private set; }

		private ViewableObjects()
		{
			if (!File.Exists(ObjectsPath))
			{
				MessageBox.Show(string.Format("Missing {0}! Will now exit", ObjectsPath));
				System.Diagnostics.Process.GetCurrentProcess().Kill();
			}

			RamixitReader reader = new RamixitReader(File.ReadAllText(ObjectsPath));
			var objects = reader.GetBranches("object").ToArray();

			string provNameColumn = reader.GetLeafValue("ProvinceNameColumn");
			ProvinceNameColumn = int.Parse(provNameColumn);

			for (int i = 0; i < objects.Length; i++)
				this.Add(new ViewableObject(objects[i]));
		}

		private static ViewableObjects instance;
		public static ViewableObjects Instance
		{
			get
			{
				if (instance == null)
					instance = new ViewableObjects();
				return instance;
			}
		}
	}
}