﻿using System;
using CoreLib.Io;
using TextWriter = System.IO.TextWriter;

namespace MapUtility
{
	public static class Global
	{
		#region Color <-> Province Id
		public static ColorToId ColorToId = new ColorToId(true);
		public static IdToColor IdToColor = new IdToColor(true);
		#endregion

		#region AdjacentTable
		/// <summary>
		/// The path where all the .tbl files are.
		/// </summary>
		public static string RootPath = "map";

		private static AdjacentTable adjTable;
		public static AdjacentTable AdjacentTable
		{
			get
			{
				if (adjTable == null)
				{
					if (!File.Exists(RootPath + @"\adjacent.tbl"))
					{
						Console.WriteLine("You must first make adjacent.tbl");
						throw new Exception("Missing file!");
					}
					adjTable = new AdjacentTable(RootPath + @"\adjacent.tbl");
				}
				return adjTable;
			}
		}
		#endregion

		#region Mapsize constants
		/*public const int Lm1Width = 936;
		public const int Lm1Height = 360;
		public const int Lm2Width = 468;
		public const int Lm2Height = 180;
		public const int Lm3Width = 234;
		public const int Lm3Height = 90;
		public const int Lm4Width = 117;
		public const int Lm4Height = 45;*/

		public const int BlockWidth = 32;
		public const int BlockHeight = 32;

		public const int TilesBlocksPerRow = 256;
		#endregion

		#region File Paths
		public const string ImageListingPath = "images.txt";
		#endregion

		#region Log
		private static TextWriter log;
		public static TextWriter Log
		{
			get
			{
				if (log == null)
					log = Console.Out;
				return log;
			}
		}
		public static void SetLog(TextWriter newLog)
		{
			log = newLog;
		}
		#endregion
	}
}